#!/bin/bash
set -e

BCK_DIR=<%= @bck_dir %>/<%= @fqdn %>
export BCK_DIR

if [ -f "$BCK_DIR/lock" ]
then
	echo "lock exists. Exiting" | logger -i -t "rdbackup"
	exit 1
else
	touch $BCK_DIR/lock
fi

echo "=== $BCK_DIR backup started at $(date) ===" | logger -i -t "rdbackup"

<% if @pre_backup_hook_path -%>

if [ -x "$BCK_DIR/_bin/<%= @fqdn %>_pre.sh" ];then
	echo "=== Run host specific pre backup hook : ===" | logger -i -t "rdbackup"
	eval $BCK_DIR/_bin/<%= @fqdn %>_pre.sh | logger -i -t "rdbackup"
	echo "=== Host specific pre backup hook done  . ===" | logger -i -t "rdbackup"
fi
		
<% end %>

<% @hosts.each do |host| -%>
echo "=== Start backing to host : <%= host %> ===" | logger -i -t "rdbackup"

<% @backup_dirs.each do |backup_dir| -%>
/usr/bin/rdiff-backup --remove-older-than <%= @retention %> --force --remote-schema 'ssh -i <%= @bck_dir %>/.ssh/id_rsa -C %s rdiff-backup --server' <%= @user %>@<%= host %>::<%= @bck_dir %>/<%= @fqdn %>/<%= backup_dir %>/ | logger -i -t "rdbackup"
/usr/bin/rdiff-backup --create-full-path --print-statistics --remote-schema 'ssh -i <%= @bck_dir %>/.ssh/id_rsa -C %s rdiff-backup --server' --exclude-device-files --exclude-fifos --exclude-sockets --exclude-globbing-filelist "${BCK_DIR}/_bin/<%= backup_dir %>_exclude" /<%= backup_dir %> <%= @user %>@<%= host %>::<%= @bck_dir %>/<%= @fqdn %>/<%= backup_dir %>/ | logger -i -t "rdbackup"
<% end -%>

echo "=== Completed backing to host : <%= host %> ===" | logger -i -t "rdbackup"

<% end -%>

<% if @post_backup_hook_path -%>

if [ -x "$BCK_DIR/_bin/<%= @fqdn %>_post.sh" ];then
	echo "=== Run host specific post backup hook : ===" | logger -i -t "rdbackup"
	eval $BCK_DIR/_bin/<%= @fqdn %>_post.sh | logger -i -t "rdbackup"
	echo "=== Host specific post backup hook done  . ===" | logger -i -t "rdbackup"
fi
		
<% end %>


rm $BCK_DIR/lock

/bin/echo '{"name": "check-rdbackup-working", "ttl": 3600, "output": "Cron is running", "status": 0}' | /bin/nc localhost 3030 >/dev/null